/*************************** (C) COPYRIGHT 2014 GLHF ****************************
 * 文件名  ：usart3.c
 * 描  述  ：串口3驱动代码(GPRS控制)    
 * 版  本  ：V1.0
 * 作  者  ：XuZhongPing
 * 日  期  ：2013/11/21 
*********************************************************************************/
#include "usart3.h"
#include "scale.h"

uint8_t USART3_RX_BUF[USART3_RECV_LEN];			//最大接收缓存
uint8_t USART3_TX_BUF[USART3_SEND_LEN];			//最大发收缓存
uint8_t USART3_RX_STA = 0;       						//接收状态标记

void USART3_ReceiveHandler(uint8_t res);
static void ScaleCmdHandler1(uint8_t rxBuf[], uint8_t bData);

/*
***********************************************************************
*	函 数 名: USART3_Init
*	功能说明: 串口3初始化
*	形    参: 无
*	返 回 值: 无
***********************************************************************
*/
void USART3_Init(uint32_t bound)
{
	//GPIO端口设置
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;

	//开启所使用的时钟
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);		//使能GPIOB时钟
 	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);		//使能USART3时钟
	
	USART_DeInit(USART3);  																	//复位串口3
	
	//USART3_TX   PB.10
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10; 							
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;					//复用推挽输出
	GPIO_Init(GPIOB, &GPIO_InitStructure); 									//初始化PB10
   
	//USART3_RX	  PB.11
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;		//浮空输入
	GPIO_Init(GPIOB, &GPIO_InitStructure);  								//初始化PB11


	//USART 初始化设置
	USART_InitStructure.USART_BaudRate = bound;												//设置波特率;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;				//字长为8位数据格式
	USART_InitStructure.USART_StopBits = USART_StopBits_1;						//一个停止位
	USART_InitStructure.USART_Parity = USART_Parity_No;								//无奇偶校验位
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;	//无硬件数据流控制
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;		//收发模式

	USART_Init(USART3, &USART_InitStructure); 								//初始化串口

	//Usart3 NVIC 配置
	NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	//抢占优先级0
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;				//子优先级1
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;						//IRQ通道使能
	NVIC_Init(&NVIC_InitStructure);														//根据指定的参数初始化VIC寄存器
   
	USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);						//开启中断
	USART_Cmd(USART3, ENABLE);                    						//使能串口 
}

/*
***********************************************************************
*	函 数 名: USART3_IRQHandler
*	功能说明: 串口中断服务程序
*	形    参：无
*	返 回 值: 无
***********************************************************************
*/
void USART3_IRQHandler(void)
{
	uint8_t res = 0;
	
	if(USART_GetITStatus(USART3, USART_IT_RXNE) != RESET)		//接收到数据
	{	 
		res = USART_ReceiveData(USART3);											//读取接收到的数据
		ScaleCmdHandler1(calibrationParam1, res);
		USART3_ReceiveHandler(res);
	}  											 
}

/*
***********************************************************************
*	函 数 名: USART3_SendByteData
*	功能说明: 发送一字节数据
*	形    参: 无
*	返 回 值: 无
***********************************************************************
*/
void USART3_SendByteData(uint8_t bData)
{ 
	USART_SendData(USART3, bData);
	while(USART_GetFlagStatus(USART3, USART_FLAG_TC) != SET);		//等待发送结束
}

/*
***********************************************************************
*	函 数 名: USART3_SendFrameData
*	功能说明: 发送一帧数据
*	形    参: pData -> 数据的首地址；len -> 数据的长度
*	返 回 值: 无
***********************************************************************
*/
void USART3_SendFrameData(uint8_t pDataBuf[], uint16_t len)
{
	uint16_t i = 0;
	
	USART_ClearFlag(USART3, USART_FLAG_TC);
	for(i = 0; i < len; i++)
	{
		USART3_SendByteData(pDataBuf[i]);
	}
}
		 
/*
***********************************************************************
*	函 数 名: UART3_ReceiveHandler
*	功能说明: 串口数据接收处理程序
*	形    参: 传入串口接收到的数据
*	返 回 值: 无（影响串口接收状态USART3_RX_STA）
***********************************************************************
*/
void USART3_ReceiveHandler(uint8_t res)
{	
	static uint8_t Byte_count = 0;	  			//接收数据字节计数
	static uint8_t receiveState = 0;				//接收状态
	
	switch(receiveState)
	{
		case 0:	  //第一开始码
			if(res == 0xF5)receiveState = 1;
			else receiveState = 0;
			break;
			
		case 1:	  //第二开始码
			if(res == 0xFA)receiveState = 2;
			else receiveState = 0;
			break;
			
		case 2:	  //第三开始码
			if(res == 0x48)receiveState = 3;
			else receiveState = 0;
			break;
			
		case 3:	  //第四开始码
			if(res == 0xA2)receiveState = 4;
			else receiveState = 0;
			break;
			
		case 4:	  //接收8个字节数据
			if(Byte_count < 7)
			{
				USART3_RX_BUF[Byte_count] = res;
				Byte_count++;
			}else{
				USART3_RX_BUF[Byte_count] = res;
				Byte_count = 0;							//已完成8个字节的数据接收计数归0
				receiveState = 5;						//转到接收核验码
			}
			break;
			
		case 5:	  //接收帧尾	
			if((res == 0x0D) || (res == 0x1D))
			{
				USART3_RX_STA = 0xfd; 				//一帧接收成功，标记USART_RX_STA=0xfd通知主程序进行通讯处理
				USART3_RX_BUF[8] = '\0';			//添加字符串结尾符
			}
			receiveState = 0;
			break;

		default:  //其它
			break;
	}							 
}

/*
***********************************************************************
*	函 数 名: ScaleCmdHandler
*	功能说明: 称重模块控制指令处理任务
*	形    参: bData -> 接收到的数据
*	返 回 值: 无（影响接收完成状态标志USART3_RX_STA）
***********************************************************************
*/
void ScaleCmdHandler1(uint8_t rxBuf[], uint8_t bData)
{
	static uint8_t RX_Status = 0;						//接收状态
	static uint8_t CS = 0;		  						//接收核验和
	static uint8_t RX_Size = 0;							//接收通讯数据长度
	static uint8_t RX_ByteCount = 0;	  		//接收数据字节计数
	
	switch(RX_Status)
	{
		case 0:	  //第一前导字节
			if(bData == 0xfe){
				RX_Status = 1;
			}else{
				RX_Status = 0;
			}
			break;
			
		case 1:	  //第二前导字节
			if(bData == 0xfe){
				RX_Status = 1;						//还是前导字节
			}else if(bData == 0x68){
				RX_Status = 3;						//转到接收设备通讯地址
				CS = 0x68;
			}else{
				RX_Status = 0;
			}
			break;

		case 3:		//接收设备通讯地址
			rxBuf[0] = bData;
			CS += bData;
			RX_Status = 4;
			break;
			
		case 4:	  //接收帧头
			if(bData == 0x68){
				RX_Status = 5;						//转到接收通讯命令
				CS += 0x68;
			}else{
				RX_Status = 0;
			}
			break;
		case 5:		//接收通讯命令
			rxBuf[1] = bData;
			CS += bData;
			RX_Status = 6;							//转到接收数据长度
			break;
			
		case 6:		//接收通讯数据长度
			rxBuf[2] = bData;
			CS += bData;
			RX_Size = bData;						//接收的数据长度
			if(RX_Size == 0x00){			//如果数据长度为0，则直接转到接收校验码
				RX_Status = 8;
			}else{
				RX_Status = 7;						//转到接收数据
			}
			break;	
			
		case 7:	  //接收N个字节数据
			if(RX_ByteCount < RX_Size-1){
				rxBuf[RX_ByteCount + 3] = bData;
				CS += bData;
				RX_ByteCount++;
			}else{
				rxBuf[RX_ByteCount + 3] = bData;
				CS += bData;
				RX_ByteCount = 0;					//已完成N个字节的数据接收计数归0
				RX_Status = 8;						//转到接收核验码
			}
			break;
			
		case 8:	  //接收校验
			if(CS != bData){
				RX_Status = 0;
			}else{
				RX_Status = 9;						//转到接收帧尾码0x16
			}
			break;
			
		case 9:	  //接收帧尾
			if(bData == 0x16){ 					//是帧尾吗？
				getCalibraDataMark1 = 1; 	//一帧接收成功，标记接收到一帧数据通知主程序进行通讯处理
			}
			RX_Status = 0;
			break;
			
		default:  //其它
			RX_Status = 0;
			break;
	}
}

/******************** (C) COPYRIGHT 2017 CXHY *****END OF FILE*******************/
